`include "pll.v"
`include "system.v"

module main(
	output TXD, 
	input  RXD, 
	input  CLKIN, 

	inout  [15:0]XD,
	output [15:0]XA,
	output XWE,
	output XOE,
	output XBHE,
	output XBLE,
	
	input  MISO,
	output MOSI,
	output SCK,
	output SSBF,
	
	output [2:0]LED,	
	output PWM

);
wire XBHE;
wire XBLE;
assign XBHE=0;
assign XBLE=0;


wire clk,pll_lock;
//-- Instanciar el PLL

pll
  pll1(
	.clock_in(CLKIN),
	.clock_out(clk),
	.locked(pll_lock)
	);

//wire clk = CLKIN;


// Reset
reg [15:0]cres=0;
always @(posedge CLKIN) cres<=reset&pll_lock ? cres+1 :cres;
wire reset=~(&cres);
//wire reset=~pll_lock;
//wire reset=0;

SYSTEM sys0( .clk(clk), .reset(reset), .led(LED), .rxd(RXD), .txd(TXD), .led(LED) );


endmodule


